Index: branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr_substitute.h90
===================================================================
--- branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr_substitute.h90	(revision 2863)
+++ branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DOM/domzgr_substitute.h90	(revision 2905)
@@ -19,39 +19,42 @@
 #   define  fse3uw_0(i,j,k)  e3uw(i,j,k)
 #   define  fse3vw_0(i,j,k)  e3vw(i,j,k)
+
 #if defined key_vvl
-! s* or z*-coordinate (3D + time dependency) + use of additional now arrays (..._1)
-#   define  fsdept(i,j,k)  gdept_1(i,j,k)
-#   define  fsdepw(i,j,k)  gdepw_1(i,j,k)
-#   define  fsde3w(i,j,k)  gdep3w_1(i,j,k)
-#   define  fse3t(i,j,k)   e3t_1(i,j,k)
-#   define  fse3u(i,j,k)   e3u_1(i,j,k)
-#   define  fse3v(i,j,k)   e3v_1(i,j,k)
-#   define  fse3f(i,j,k)   e3f_1(i,j,k)
-#   define  fse3w(i,j,k)   e3w_1(i,j,k)
-#   define  fse3uw(i,j,k)  e3uw_1(i,j,k)
-#   define  fse3vw(i,j,k)  e3vw_1(i,j,k)
+! s* or z*-coordinate (3D + time dependency) + use of additional now arrays (..._n)
 
 #   define  fse3t_b(i,j,k)   e3t_b(i,j,k)
 #   define  fse3u_b(i,j,k)   e3u_b(i,j,k)
 #   define  fse3v_b(i,j,k)   e3v_b(i,j,k)
-#   define  fse3uw_b(i,j,k)  (fse3uw_0(i,j,k)*(1.+sshu_b(i,j)*muu(i,j,k)))
-#   define  fse3vw_b(i,j,k)  (fse3vw_0(i,j,k)*(1.+sshv_b(i,j)*muv(i,j,k)))
+#   define  fse3uw_b(i,j,k)  e3uw_b(i,j,k)
+#   define  fse3vw_b(i,j,k)  e3vw_b(i,j,k)
 
-#   define  fsdept_n(i,j,k)  (fsdept_0(i,j,k)*(1.+sshn(i,j)*mut(i,j,k)))
-#   define  fsdepw_n(i,j,k)  (fsdepw_0(i,j,k)*(1.+sshn(i,j)*mut(i,j,k)))
-#   define  fsde3w_n(i,j,k)  (fsde3w_0(i,j,k)*(1.+sshn(i,j)*mut(i,j,k))-sshn(i,j))
-#   define  fse3t_n(i,j,k)   (fse3t_0(i,j,k)*(1.+sshn(i,j)*mut(i,j,k)))
-#   define  fse3u_n(i,j,k)   (fse3u_0(i,j,k)*(1.+sshu_n(i,j)*muu(i,j,k)))
-#   define  fse3v_n(i,j,k)   (fse3v_0(i,j,k)*(1.+sshv_n(i,j)*muv(i,j,k)))
-#   define  fse3f_n(i,j,k)   (fse3f_0(i,j,k)*(1.+sshf_n(i,j)*muf(i,j,k)))
-#   define  fse3w_n(i,j,k)   (fse3w_0(i,j,k)*(1.+sshn(i,j)*mut(i,j,k)))
-#   define  fse3uw_n(i,j,k)  (fse3uw_0(i,j,k)*(1.+sshu_n(i,j)*muu(i,j,k)))
-#   define  fse3vw_n(i,j,k)  (fse3vw_0(i,j,k)*(1.+sshv_n(i,j)*muv(i,j,k)))
+#   define  fsdept_n(i,j,k)  gdept_n(i,j,k)
+#   define  fsdepw_n(i,j,k)  gdepw_n(i,j,k)
+#   define  fsde3w_n(i,j,k)  gdep3w_n(i,j,k)
+#   define  fse3t_n(i,j,k)   e3t_n(i,j,k)
+#   define  fse3u_n(i,j,k)   e3u_n(i,j,k)
+#   define  fse3v_n(i,j,k)   e3v_n(i,j,k)
+#   define  fse3f_n(i,j,k)   e3f_n(i,j,k)
+#   define  fse3w_n(i,j,k)   e3w_n(i,j,k)
+#   define  fse3uw_n(i,j,k)  e3uw_n(i,j,k)
+#   define  fse3vw_n(i,j,k)  e3vw_n(i,j,k)
 
-#   define  fse3t_m(i,j,k)   (fse3t_0(i,j,k)*(1.+ssh_m(i,j)*mut(i,j,k)))
+#   define  fse3t_a(i,j,k)   e3t_a(i,j,k)
+#   define  fse3u_a(i,j,k)   e3u_a(i,j,k)
+#   define  fse3v_a(i,j,k)   e3v_a(i,j,k)
 
-#   define  fse3t_a(i,j,k)   (fse3t_0(i,j,k)*(1.+ssha(i,j)*mut(i,j,k)))
-#   define  fse3u_a(i,j,k)   (fse3u_0(i,j,k)*(1.+sshu_a(i,j)*muu(i,j,k)))
-#   define  fse3v_a(i,j,k)   (fse3v_0(i,j,k)*(1.+sshv_a(i,j)*muv(i,j,k)))
+#   define  fse3t_m(i,j)   e3t_m(i,j)
+
+! This part should be removed one day ...
+#   define  fsdept(i,j,k)  fsdept_n(i,j,k)
+#   define  fsdepw(i,j,k)  fsdepw_n(i,j,k)
+#   define  fsde3w(i,j,k)  fsde3w_n(i,j,k)
+#   define  fse3t(i,j,k)   fse3t_n(i,j,k) 
+#   define  fse3u(i,j,k)   fse3u_n(i,j,k) 
+#   define  fse3v(i,j,k)   fse3v_n(i,j,k) 
+#   define  fse3f(i,j,k)   fse3f_n(i,j,k) 
+#   define  fse3w(i,j,k)   fse3w_n(i,j,k) 
+#   define  fse3uw(i,j,k)  fse3uw_n(i,j,k)
+#   define  fse3vw(i,j,k)  fse3vw_n(i,j,k)
 
 #else
@@ -85,5 +88,5 @@
 #   define  fse3vw_n(i,j,k)  fse3vw_0(i,j,k)
 
-#   define  fse3t_m(i,j,k)   fse3t_0(i,j,k)
+#   define  fse3t_m(i,j)     fse3t_0(i,j,1)
 
 #   define  fse3t_a(i,j,k)   fse3t_0(i,j,k)
Index: branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90
===================================================================
--- branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2863)
+++ branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynnxt.F90	(revision 2905)
@@ -92,7 +92,5 @@
       !!               un,vn   now horizontal velocity of next time-step
       !!----------------------------------------------------------------------
-      USE wrk_nemo, ONLY:   wrk_in_use, wrk_not_released
       USE oce     , ONLY:   ze3u_f => ta       , ze3v_f => sa       ! (ta,sa) used as 3D workspace
-      USE wrk_nemo, ONLY:   zs_t   => wrk_2d_1 , zs_u_1 => wrk_2d_2 , zs_v_1 => wrk_2d_3
       !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index
@@ -104,10 +102,6 @@
       REAL(wp) ::   zue3a, zue3n, zue3b, zuf    ! local scalars
       REAL(wp) ::   zve3a, zve3n, zve3b, zvf    !   -      -
-      REAL(wp) ::   zec, zv_t_ij, zv_t_ip1j, zv_t_ijp1
+      REAL(wp) ::   zec                         !   -      -
       !!----------------------------------------------------------------------
-
-      IF( wrk_in_use(2, 1,2,3) ) THEN
-         CALL ctl_stop('dyn_nxt: requested workspace arrays unavailable')   ;   RETURN
-      ENDIF
 
       IF( kt == nit000 ) THEN
@@ -185,6 +179,6 @@
          hvr_e(:,:) = hvr(:,:)
          DO jk = 1, jpkm1   !! Vertically integrated momentum trends
-            ua_e(:,:) = ua_e(:,:) + fse3u(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
-            va_e(:,:) = va_e(:,:) + fse3v(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
+            ua_e(:,:) = ua_e(:,:) + fse3u_n(:,:,jk) * umask(:,:,jk) * ua(:,:,jk)
+            va_e(:,:) = va_e(:,:) + fse3v_n(:,:,jk) * vmask(:,:,jk) * va(:,:,jk)
          END DO
          ua_e(:,:) = ua_e(:,:) * hur(:,:)
@@ -239,5 +233,6 @@
             !                             ! ================!
             ! Before scale factor at t-points
-            ! -------------------------------
+            ! (used as a now filtered scale factor until the swap)
+            ! ----------------------------------------------------
             DO jk = 1, jpkm1
                fse3t_b(:,:,jk) = fse3t_n(:,:,jk)                                   &
@@ -245,33 +240,16 @@
                   &                         - 2.e0 * fse3t_n(:,:,jk)            )
             ENDDO
-            ! Add volume filter correction only at the first level of t-point scale factors
+            ! Add volume filter correction: comatibility with tracer advection scheme
+            ! => time filter + conservation correction (only at the first level)
             zec = atfp * rdt / rau0
             fse3t_b(:,:,1) = fse3t_b(:,:,1) - zec * ( emp_b(:,:) - emp(:,:) ) * tmask(:,:,1)
-            ! surface at t-points and inverse surface at (u/v)-points used in surface averaging computations
-            zs_t  (:,:) =       e1t(:,:) * e2t(:,:)
-            zs_u_1(:,:) = 0.5 / e1u(:,:) * e2u(:,:)
-            zs_v_1(:,:) = 0.5 / e1v(:,:) * e2v(:,:)
+            ! swap of emp fields
+            emp_b(:,:) = emp(:,:)
             !
             IF( ln_dynadv_vec ) THEN
                ! Before scale factor at (u/v)-points
                ! -----------------------------------
-               ! Scale factor anomaly at (u/v)-points: surface averaging of scale factor at t-points
-               DO jk = 1, jpkm1
-                  DO jj = 1, jpjm1
-                     DO ji = 1, jpim1
-                        zv_t_ij           = zs_t(ji  ,jj  ) * fse3t_b(ji  ,jj  ,jk)
-                        zv_t_ip1j         = zs_t(ji+1,jj  ) * fse3t_b(ji+1,jj  ,jk)
-                        zv_t_ijp1         = zs_t(ji  ,jj+1) * fse3t_b(ji  ,jj+1,jk)
-                        fse3u_b(ji,jj,jk) = umask(ji,jj,jk) * ( zs_u_1(ji,jj) * ( zv_t_ij + zv_t_ip1j ) - fse3u_0(ji,jj,jk) )
-                        fse3v_b(ji,jj,jk) = vmask(ji,jj,jk) * ( zs_v_1(ji,jj) * ( zv_t_ij + zv_t_ijp1 ) - fse3v_0(ji,jj,jk) )
-                     END DO
-                  END DO
-               END DO
-               ! lateral boundary conditions
-               CALL lbc_lnk( fse3u_b(:,:,:), 'U', 1. )
-               CALL lbc_lnk( fse3v_b(:,:,:), 'V', 1. )
-               ! Add initial scale factor to scale factor anomaly
-               fse3u_b(:,:,:) = fse3u_b(:,:,:) + fse3u_0(:,:,:)
-               fse3v_b(:,:,:) = fse3v_b(:,:,:) + fse3v_0(:,:,:)
+               CALL dom_vvl_interpol( fse3t_b(:,:,:), fse3u_b(:,:,:), 'U' )
+               CALL dom_vvl_interpol( fse3t_b(:,:,:), fse3v_b(:,:,:), 'V' )
                ! Leap-Frog - Asselin filter and swap: applied on velocity
                ! -----------------------------------
@@ -291,24 +269,8 @@
                !
             ELSE
-               ! Temporary filered scale factor at (u/v)-points (will become before scale factor)
-               !-----------------------------------------------
-               ! Scale factor anomaly at (u/v)-points: surface averaging of scale factor at t-points
-               DO jk = 1, jpkm1
-                  DO jj = 1, jpjm1
-                     DO ji = 1, jpim1
-                        zv_t_ij          = zs_t(ji  ,jj  ) * fse3t_b(ji  ,jj  ,jk)
-                        zv_t_ip1j        = zs_t(ji+1,jj  ) * fse3t_b(ji+1,jj  ,jk)
-                        zv_t_ijp1        = zs_t(ji  ,jj+1) * fse3t_b(ji  ,jj+1,jk)
-                        ze3u_f(ji,jj,jk) = umask(ji,jj,jk) * ( zs_u_1(ji,jj) * ( zv_t_ij + zv_t_ip1j ) - fse3u_0(ji,jj,jk) )
-                        ze3v_f(ji,jj,jk) = vmask(ji,jj,jk) * ( zs_v_1(ji,jj) * ( zv_t_ij + zv_t_ijp1 ) - fse3v_0(ji,jj,jk) )
-                     END DO
-                  END DO
-               END DO
-               ! lateral boundary conditions
-               CALL lbc_lnk( ze3u_f, 'U', 1. )
-               CALL lbc_lnk( ze3v_f, 'V', 1. )
-               ! Add initial scale factor to scale factor anomaly
-               ze3u_f(:,:,:) = ze3u_f(:,:,:) + fse3u_0(:,:,:)
-               ze3v_f(:,:,:) = ze3v_f(:,:,:) + fse3v_0(:,:,:)
+               ! Temporary filtered scale factor at (u/v)-points (will become before scale factor)
+               !------------------------------------------------
+               CALL dom_vvl_interpol( fse3t_b(:,:,:), ze3u_f, 'U' )
+               CALL dom_vvl_interpol( fse3t_b(:,:,:), ze3v_f, 'V' )
                ! Leap-Frog - Asselin filter and swap: applied on thickness weighted velocity
                ! -----------------------------------             ===========================
@@ -345,6 +307,5 @@
       IF(ln_ctl)   CALL prt_ctl( tab3d_1=un, clinfo1=' nxt  - Un: ', mask1=umask,   &
          &                       tab3d_2=vn, clinfo2=' Vn: '       , mask2=vmask )
-      ! 
-      IF( wrk_not_released(2, 1,2,3) )   CALL ctl_stop('dyn_nxt: failed to release workspace arrays')
+      !
       !
    END SUBROUTINE dyn_nxt
Index: branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90
===================================================================
--- branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2863)
+++ branches/2011/dev_r2739_LOCEAN8_ZTC/NEMOGCM/NEMO/OPA_SRC/DYN/dynspg_ts.F90	(revision 2905)
@@ -114,4 +114,5 @@
       USE wrk_nemo, ONLY:   zun => wrk_2d_14 , zun_e => wrk_2d_15 , zub_e => wrk_2d_16 , zu_sum => wrk_2d_17
       USE wrk_nemo, ONLY:   zvn => wrk_2d_18 , zvn_e => wrk_2d_19 , zvb_e => wrk_2d_20 , zv_sum => wrk_2d_21
+      USE wrk_nemo, ONLY:   zhu_b => wrk_2d_22 , zhv_b => wrk_2d_23
       !
       INTEGER, INTENT(in)  ::   kt   ! ocean time-step index
@@ -127,5 +128,5 @@
 
       IF( wrk_in_use(2,  1, 2, 3, 4, 5, 6, 7, 8, 9,10,     &
-         &              11,12,13,14,15,16,17,18,19,20,21 ) ) THEN
+         &              11,12,13,14,15,16,17,18,19,20,21,22,23 ) ) THEN
          CALL ctl_stop( 'dyn_spg_ts: requested workspace arrays unavailable' )   ;   RETURN
       ENDIF
@@ -188,20 +189,30 @@
 #endif
                !                                                                              ! now trend
-               zua(ji,jj) = zua(ji,jj) + fse3u  (ji,jj,jk) * ua(ji,jj,jk) * umask(ji,jj,jk)
-               zva(ji,jj) = zva(ji,jj) + fse3v  (ji,jj,jk) * va(ji,jj,jk) * vmask(ji,jj,jk)
+               zua(ji,jj) = zua(ji,jj) + fse3u_n(ji,jj,jk) * ua(ji,jj,jk) * umask(ji,jj,jk)
+               zva(ji,jj) = zva(ji,jj) + fse3v_n(ji,jj,jk) * va(ji,jj,jk) * vmask(ji,jj,jk)
                !                                                                              ! now velocity 
-               zun(ji,jj) = zun(ji,jj) + fse3u  (ji,jj,jk) * un(ji,jj,jk)
-               zvn(ji,jj) = zvn(ji,jj) + fse3v  (ji,jj,jk) * vn(ji,jj,jk)               
+               zun(ji,jj) = zun(ji,jj) + fse3u_n(ji,jj,jk) * un(ji,jj,jk)
+               zvn(ji,jj) = zvn(ji,jj) + fse3v_n(ji,jj,jk) * vn(ji,jj,jk)               
                !
-#if defined key_vvl
-               ub_b(ji,jj) = ub_b(ji,jj) + (fse3u_0(ji,jj,jk)*(1.+sshu_b(ji,jj)*muu(ji,jj,jk)))* ub(ji,jj,jk) 
-               vb_b(ji,jj) = vb_b(ji,jj) + (fse3v_0(ji,jj,jk)*(1.+sshv_b(ji,jj)*muv(ji,jj,jk)))* vb(ji,jj,jk)   
-#else
-               ub_b(ji,jj) = ub_b(ji,jj) + fse3u_0(ji,jj,jk) * ub(ji,jj,jk)  * umask(ji,jj,jk)
-               vb_b(ji,jj) = vb_b(ji,jj) + fse3v_0(ji,jj,jk) * vb(ji,jj,jk)  * vmask(ji,jj,jk)
-#endif
+               ub_b(ji,jj) = ub_b(ji,jj) + fse3u_b(ji,jj,jk) * ub(ji,jj,jk)  * umask(ji,jj,jk)
+               vb_b(ji,jj) = vb_b(ji,jj) + fse3v_b(ji,jj,jk) * vb(ji,jj,jk)  * vmask(ji,jj,jk)
             END DO
          END DO
       END DO
+
+      ! before inverse water column height at u- and v- points
+      IF( lk_vvl ) THEN
+         zhu_b(:,:) = 0.
+         zhv_b(:,:) = 0.
+         DO jk = 1, jpk
+            zhu_b(:,:) = zhu_b(:,:) + fse3u_b(:,:,jk) * umask(:,:,jk)
+            zhv_b(:,:) = zhv_b(:,:) + fse3v_b(:,:,jk) * vmask(:,:,jk)
+         END DO
+         zhu_b(:,:) = umask(:,:,1) / ( zhu_b(:,:) + 1. - umask(:,:,1) )
+         zhv_b(:,:) = vmask(:,:,1) / ( zhv_b(:,:) + 1. - vmask(:,:,1) )
+      ELSE
+         zhu_b(:,:) = hur(:,:)
+         zhv_b(:,:) = hvr(:,:)
+      ENDIF
 
       !                                   !* baroclinic momentum trend (remove the vertical mean trend)
@@ -289,26 +300,15 @@
             !RBbug for vvl and external mode we may need to use varying fse3
             !!gm  Rq: the bottom e3 present the smallest variation, the use of e3u_0 is not a big approx.
-            zbfru(ji,jj) = MAX(  bfrua(ji,jj) , fse3u(ji,jj,mbku(ji,jj)) * zcoef  )
-            zbfrv(ji,jj) = MAX(  bfrva(ji,jj) , fse3v(ji,jj,mbkv(ji,jj)) * zcoef  )
+            zbfru(ji,jj) = MAX(  bfrua(ji,jj) , fse3u_n(ji,jj,mbku(ji,jj)) * zcoef  )
+            zbfrv(ji,jj) = MAX(  bfrva(ji,jj) , fse3v_n(ji,jj,mbkv(ji,jj)) * zcoef  )
          END DO
       END DO
-
-      IF( lk_vvl ) THEN
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * ub_b(ji,jj)   &
-                  &       / ( hu_0(ji,jj) + sshu_b(ji,jj) + 1.e0 - umask(ji,jj,1) )
-               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * vb_b(ji,jj)   &
-                  &       / ( hv_0(ji,jj) + sshv_b(ji,jj) + 1.e0 - vmask(ji,jj,1) )
-            END DO
-         END DO
-      ELSE
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-               zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * ub_b(ji,jj) * hur(ji,jj)
-               zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * vb_b(ji,jj) * hvr(ji,jj)
-            END DO
-         END DO
-      ENDIF
+      
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1   ! vector opt.
+            zua(ji,jj) = zua(ji,jj) - zbfru(ji,jj) * ub_b(ji,jj) * zhu_b(ji,jj)
+            zva(ji,jj) = zva(ji,jj) - zbfrv(ji,jj) * vb_b(ji,jj) * zhv_b(ji,jj)
+         END DO
+      END DO
 
       !                                   !* d/dt(Ua), Ub, Vn (Vertical mean velocity)
@@ -317,11 +317,6 @@
       zva(:,:) = zva(:,:) * hvr(:,:)
       !
-      IF( lk_vvl ) THEN
-         ub_b(:,:) = ub_b(:,:) * umask(:,:,1) / ( hu_0(:,:) + sshu_b(:,:) + 1.e0 - umask(:,:,1) )
-         vb_b(:,:) = vb_b(:,:) * vmask(:,:,1) / ( hv_0(:,:) + sshv_b(:,:) + 1.e0 - vmask(:,:,1) )
-      ELSE
-         ub_b(:,:) = ub_b(:,:) * hur(:,:)
-         vb_b(:,:) = vb_b(:,:) * hvr(:,:)
-      ENDIF
+      ub_b(:,:) = ub_b(:,:) * zhu_b(:,:)
+      vb_b(:,:) = vb_b(:,:) * zhv_b(:,:)
 
       ! -----------------------------------------------------------------------
@@ -640,15 +635,6 @@
             ENDIF
 
-            IF( lk_vvl ) THEN
-               ub_b (:,:) = ub_b(:,:) * umask(:,:,1) / ( hu_0(:,:) + sshu_b(:,:) + 1.e0 - umask(:,:,1) )
-               vb_b (:,:) = vb_b(:,:) * vmask(:,:,1) / ( hv_0(:,:) + sshv_b(:,:) + 1.e0 - vmask(:,:,1) )
-            ELSE
-               ub_b(:,:) = ub_b(:,:) * hur(:,:)
-               vb_b(:,:) = vb_b(:,:) * hvr(:,:)
-            ENDIF
-         ELSE                                 ! neuler==0
-            ub_b (:,:) = un_b (:,:)
-            vb_b (:,:) = vn_b (:,:)
-         ENDIF
+            ub_b(:,:) = ub_b(:,:) * zhu_b(:,:)
+            vb_b(:,:) = vb_b(:,:) * zhv_b(:,:)
 
          IF( iom_varid( numror, 'sshn_b', ldstop = .FALSE. ) > 0 ) THEN
